diff --git a/rsvg-cairo-draw.c b/rsvg-cairo-draw.c
index 6c71a60..f100d9f 100644
--- a/rsvg-cairo-draw.c
+++ b/rsvg-cairo-draw.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-shapes.c: Draw shapes with cairo
 
@@ -30,7 +31,6 @@
 #include "rsvg-cairo-render.h"
 #include "rsvg-cairo-clip.h"
 #include "rsvg-styles.h"
-#include "rsvg-bpath-util.h"
 #include "rsvg-path.h"
 #include "rsvg-filter.h"
 #include "rsvg-structure.h"
@@ -41,97 +41,7 @@
 
 #include <pango/pangocairo.h>
 
-static void
-_rsvg_cairo_set_shape_antialias (cairo_t * cr, ShapeRenderingProperty aa)
-{
-	if (SHAPE_RENDERING_AUTO == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-	else if (SHAPE_RENDERING_OPTIMIZE_SPEED == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE);
-	else if (SHAPE_RENDERING_CRISP_EDGES == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-	else if (SHAPE_RENDERING_GEOMETRIC_PRECISION == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-}
-
-static void
-_rsvg_cairo_set_text_antialias (cairo_t * cr, TextRenderingProperty aa)
-{
-	if (TEXT_RENDERING_AUTO == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-	else if (TEXT_RENDERING_OPTIMIZE_SPEED == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_NONE);
-	else if (TEXT_RENDERING_OPTIMIZE_LEGIBILITY == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-	else if (TEXT_RENDERING_GEOMETRIC_PRECISION == aa)
-		cairo_set_antialias (cr, CAIRO_ANTIALIAS_DEFAULT);
-}
-
-static void
-_rsvg_cairo_set_operator (cairo_t * cr, RsvgCompOpType comp_op)
-{
-    cairo_operator_t op;
-
-    switch (comp_op) {
-    case RSVG_COMP_OP_CLEAR:
-        op = CAIRO_OPERATOR_CLEAR;
-        break;
-    case RSVG_COMP_OP_SRC:
-        op = CAIRO_OPERATOR_SOURCE;
-        break;
-    case RSVG_COMP_OP_DST:
-        op = CAIRO_OPERATOR_DEST;
-        break;
-    case RSVG_COMP_OP_DST_OVER:
-        op = CAIRO_OPERATOR_DEST_OVER;
-        break;
-    case RSVG_COMP_OP_SRC_IN:
-        op = CAIRO_OPERATOR_IN;
-        break;
-    case RSVG_COMP_OP_DST_IN:
-        op = CAIRO_OPERATOR_DEST_IN;
-        break;
-    case RSVG_COMP_OP_SRC_OUT:
-        op = CAIRO_OPERATOR_OUT;
-        break;
-    case RSVG_COMP_OP_DST_OUT:
-        op = CAIRO_OPERATOR_DEST_OUT;
-        break;
-    case RSVG_COMP_OP_SRC_ATOP:
-        op = CAIRO_OPERATOR_ATOP;
-        break;
-    case RSVG_COMP_OP_DST_ATOP:
-        op = CAIRO_OPERATOR_DEST_ATOP;
-        break;
-    case RSVG_COMP_OP_XOR:
-        op = CAIRO_OPERATOR_XOR;
-        break;
-    case RSVG_COMP_OP_PLUS:
-	op = CAIRO_OPERATOR_ADD;
-	break;
-    case RSVG_COMP_OP_MULTIPLY:
-    case RSVG_COMP_OP_SCREEN:
-    case RSVG_COMP_OP_OVERLAY:
-    case RSVG_COMP_OP_DARKEN:
-    case RSVG_COMP_OP_LIGHTEN:
-    case RSVG_COMP_OP_COLOR_DODGE:
-    case RSVG_COMP_OP_COLOR_BURN:
-    case RSVG_COMP_OP_HARD_LIGHT:
-    case RSVG_COMP_OP_SOFT_LIGHT:
-    case RSVG_COMP_OP_DIFFERENCE:
-    case RSVG_COMP_OP_EXCLUSION:
-    default:
-        op = CAIRO_OPERATOR_OVER;
-        break;
-    }
-    cairo_set_operator (cr, op);
-}
-
-static void
-rsvg_pixmap_destroy (gchar * pixels, gpointer data)
-{
-    g_free (pixels);
-}
+static const cairo_user_data_key_t surface_pixel_data_key;
 
 static void
 _pattern_add_rsvg_color_stops (cairo_pattern_t * pattern,
@@ -144,7 +54,7 @@ _pattern_add_rsvg_color_stops (cairo_pattern_t * pattern,
 
     for (i = 0; i < stops->len; i++) {
         node = (RsvgNode *) g_ptr_array_index (stops, i);
-        if (strcmp (node->type->str, "stop"))
+        if (RSVG_NODE_TYPE (node) != RSVG_NODE_TYPE_STOP)
             continue;
         stop = (RsvgGradientStop *) node;
         rgba = stop->rgba;
@@ -161,13 +71,14 @@ _set_source_rsvg_linear_gradient (RsvgDrawingCtx * ctx,
                                   RsvgLinearGradient * linear,
                                   guint32 current_color_rgb, guint8 opacity, RsvgBbox bbox)
 {
-    cairo_t *cr = ((RsvgCairoRender *) ctx->render)->cr;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    cairo_t *cr = render->cr;
     cairo_pattern_t *pattern;
     cairo_matrix_t matrix;
     RsvgLinearGradient statlinear;
     statlinear = *linear;
     linear = &statlinear;
-    rsvg_linear_gradient_fix_fallback (linear);
+    rsvg_linear_gradient_fix_fallback (ctx, linear);
 
     if (linear->has_current_color)
         current_color_rgb = linear->current_color;
@@ -182,21 +93,16 @@ _set_source_rsvg_linear_gradient (RsvgDrawingCtx * ctx,
     if (linear->obj_bbox)
         _rsvg_pop_view_box (ctx);
 
-    cairo_matrix_init (&matrix,
-                       linear->affine[0], linear->affine[1],
-                       linear->affine[2], linear->affine[3], linear->affine[4], linear->affine[5]);
+    matrix = linear->affine;
     if (linear->obj_bbox) {
         cairo_matrix_t bboxmatrix;
-        cairo_matrix_init (&bboxmatrix, bbox.w, 0, 0, bbox.h, bbox.x, bbox.y);
+        cairo_matrix_init (&bboxmatrix, bbox.rect.width, 0, 0, bbox.rect.height,
+                           bbox.rect.x, bbox.rect.y);
         cairo_matrix_multiply (&matrix, &matrix, &bboxmatrix);
     }
     cairo_matrix_invert (&matrix);
     cairo_pattern_set_matrix (pattern, &matrix);
-
-    if (linear->spread == RSVG_GRADIENT_REFLECT)
-        cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REFLECT);
-    else if (linear->spread == RSVG_GRADIENT_REPEAT)
-        cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REPEAT);
+    cairo_pattern_set_extend (pattern, linear->spread);
 
     _pattern_add_rsvg_color_stops (pattern, linear->super.children, current_color_rgb, opacity);
 
@@ -209,13 +115,14 @@ _set_source_rsvg_radial_gradient (RsvgDrawingCtx * ctx,
                                   RsvgRadialGradient * radial,
                                   guint32 current_color_rgb, guint8 opacity, RsvgBbox bbox)
 {
-    cairo_t *cr = ((RsvgCairoRender *) ctx->render)->cr;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    cairo_t *cr = render->cr;
     cairo_pattern_t *pattern;
     cairo_matrix_t matrix;
     RsvgRadialGradient statradial;
     statradial = *radial;
     radial = &statradial;
-    rsvg_radial_gradient_fix_fallback (radial);
+    rsvg_radial_gradient_fix_fallback (ctx, radial);
 
     if (radial->has_current_color)
         current_color_rgb = radial->current_color;
@@ -231,22 +138,17 @@ _set_source_rsvg_radial_gradient (RsvgDrawingCtx * ctx,
     if (radial->obj_bbox)
         _rsvg_pop_view_box (ctx);
 
-    cairo_matrix_init (&matrix,
-                       radial->affine[0], radial->affine[1],
-                       radial->affine[2], radial->affine[3], radial->affine[4], radial->affine[5]);
+    matrix = radial->affine;
     if (radial->obj_bbox) {
         cairo_matrix_t bboxmatrix;
-        cairo_matrix_init (&bboxmatrix, bbox.w, 0, 0, bbox.h, bbox.x, bbox.y);
+        cairo_matrix_init (&bboxmatrix, bbox.rect.width, 0, 0, bbox.rect.height,
+                           bbox.rect.x, bbox.rect.y);
         cairo_matrix_multiply (&matrix, &matrix, &bboxmatrix);
     }
 
     cairo_matrix_invert (&matrix);
     cairo_pattern_set_matrix (pattern, &matrix);
-
-    if (radial->spread == RSVG_GRADIENT_REFLECT)
-        cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REFLECT);
-    else if (radial->spread == RSVG_GRADIENT_REPEAT)
-        cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REPEAT);
+    cairo_pattern_set_extend (pattern, radial->spread);
 
     _pattern_add_rsvg_color_stops (pattern, radial->super.children, current_color_rgb, opacity);
 
@@ -255,46 +157,43 @@ _set_source_rsvg_radial_gradient (RsvgDrawingCtx * ctx,
 }
 
 static void
-_set_source_rsvg_solid_colour (RsvgDrawingCtx * ctx,
-                               RsvgSolidColour * colour, guint8 opacity, guint32 current_colour)
+_set_source_rsvg_solid_color (RsvgDrawingCtx * ctx,
+                              RsvgSolidColor * color, guint8 opacity, guint32 current_color)
 {
-    cairo_t *cr = ((RsvgCairoRender *) ctx->render)->cr;
-    guint32 rgb = colour->rgb;
-    double r, g, b;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    cairo_t *cr = render->cr;
+    guint32 argb = color->argb;
+    double r, g, b, a;
 
-    if (colour->currentcolour)
-        rgb = current_colour;
+    if (color->currentcolor)
+        argb = current_color;
 
-    r = ((rgb >> 16) & 0xff) / 255.0;
-    g = ((rgb >> 8) & 0xff) / 255.0;
-    b = ((rgb >> 0) & 0xff) / 255.0;
+    r = ((argb >> 16) & 0xff) / 255.0;
+    g = ((argb >>  8) & 0xff) / 255.0;
+    b = ((argb >>  0) & 0xff) / 255.0;
+    a =  (argb >> 24) / 255.0 * (opacity / 255.0);
 
-    if (opacity == 0xff)
-        cairo_set_source_rgb (cr, r, g, b);
-    else
-        cairo_set_source_rgba (cr, r, g, b, opacity / 255.0);
+    cairo_set_source_rgba (cr, r, g, b, a);
 }
 
 static void
 _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
                           RsvgPattern * rsvg_pattern, guint8 opacity, RsvgBbox bbox)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
     RsvgPattern local_pattern = *rsvg_pattern;
     cairo_t *cr_render, *cr_pattern;
     cairo_pattern_t *pattern;
     cairo_surface_t *surface;
     cairo_matrix_t matrix;
-    int i;
-    double affine[6], caffine[6], bbwscale, bbhscale, scwscale, schscale;
-    double taffine[6], patternw, patternh, patternx, patterny;
+    cairo_matrix_t affine, caffine, taffine;
+    double bbwscale, bbhscale, scwscale, schscale;
+    double patternw, patternh, patternx, patterny;
     int pw, ph;
 
     rsvg_pattern = &local_pattern;
-    rsvg_pattern_fix_fallback (rsvg_pattern);
+    rsvg_pattern_fix_fallback (ctx, rsvg_pattern);
     cr_render = render->cr;
-    _rsvg_affine_identity (affine);
-    _rsvg_affine_identity (caffine);
 
     if (rsvg_pattern->obj_bbox)
         _rsvg_push_view_box (ctx, 1., 1.);
@@ -312,17 +211,17 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
 
 
     if (rsvg_pattern->obj_bbox) {
-        bbwscale = bbox.w;
-        bbhscale = bbox.h;
+        bbwscale = bbox.rect.width;
+        bbhscale = bbox.rect.height;
     } else {
         bbwscale = 1.0;
         bbhscale = 1.0;
     }
 
-    _rsvg_affine_multiply (taffine, rsvg_pattern->affine, rsvg_state_current (ctx)->affine);
+    cairo_matrix_multiply (&taffine, &rsvg_pattern->affine, &rsvg_current_state (ctx)->affine);
 
-    scwscale = sqrt (taffine[0] * taffine[0] + taffine[2] * taffine[2]);
-    schscale = sqrt (taffine[1] * taffine[1] + taffine[3] * taffine[3]);
+    scwscale = sqrt (taffine.xx * taffine.xx + taffine.xy * taffine.xy);
+    schscale = sqrt (taffine.yx * taffine.yx + taffine.yy * taffine.yy);
 
     pw = patternw * bbwscale * scwscale;
     ph = patternh * bbhscale * schscale;
@@ -337,15 +236,15 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
     /* Create the pattern coordinate system */
     if (rsvg_pattern->obj_bbox) {
         /* subtract the pattern origin */
-        affine[4] = bbox.x + patternx * bbox.w;
-        affine[5] = bbox.y + patterny * bbox.h;
+        cairo_matrix_init_translate (&affine,
+                                     bbox.rect.x + patternx * bbox.rect.width,
+                                     bbox.rect.y + patterny * bbox.rect.height);
     } else {
         /* subtract the pattern origin */
-        affine[4] = patternx;
-        affine[5] = patterny;
+        cairo_matrix_init_translate (&affine, patternx, patterny);
     }
     /* Apply the pattern transform */
-    _rsvg_affine_multiply (affine, affine, rsvg_pattern->affine);
+    cairo_matrix_multiply (&affine, &affine, &rsvg_pattern->affine);
 
     /* Create the pattern contents coordinate system */
     if (rsvg_pattern->vbox.active) {
@@ -356,29 +255,35 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
         x = 0;
         y = 0;
         rsvg_preserve_aspect_ratio (rsvg_pattern->preserve_aspect_ratio,
-                                    rsvg_pattern->vbox.w, rsvg_pattern->vbox.h, &w, &h, &x, &y);
-
-        x -= rsvg_pattern->vbox.x * w / rsvg_pattern->vbox.w;
-        y -= rsvg_pattern->vbox.y * h / rsvg_pattern->vbox.h;
-
-        caffine[0] = w / rsvg_pattern->vbox.w;
-        caffine[3] = h / rsvg_pattern->vbox.h;
-        caffine[4] = x;
-        caffine[5] = y;
-        _rsvg_push_view_box (ctx, rsvg_pattern->vbox.w, rsvg_pattern->vbox.h);
+                                    rsvg_pattern->vbox.rect.width, rsvg_pattern->vbox.rect.height,
+                                    &w, &h, &x, &y);
+
+        x -= rsvg_pattern->vbox.rect.x * w / rsvg_pattern->vbox.rect.width;
+        y -= rsvg_pattern->vbox.rect.y * h / rsvg_pattern->vbox.rect.height;
+
+        cairo_matrix_init (&caffine,
+                           w / rsvg_pattern->vbox.rect.width,
+                           0,
+                           0,
+                           h / rsvg_pattern->vbox.rect.height,
+                           x,
+                           y);
+        _rsvg_push_view_box (ctx, rsvg_pattern->vbox.rect.width, rsvg_pattern->vbox.rect.height);
     } else if (rsvg_pattern->obj_cbbox) {
         /* If coords are in terms of the bounding box, use them */
-        caffine[0] = bbox.w;
-        caffine[3] = bbox.h;
+        cairo_matrix_init_scale (&caffine, bbox.rect.width, bbox.rect.height);
         _rsvg_push_view_box (ctx, 1., 1.);
+    } else {
+        cairo_matrix_init_identity (&caffine);
     }
 
     if (scwscale != 1.0 || schscale != 1.0) {
-        double scalematrix[6];
-        _rsvg_affine_scale (scalematrix, scwscale, schscale);
-        _rsvg_affine_multiply (caffine, caffine, scalematrix);
-        _rsvg_affine_scale (scalematrix, 1. / scwscale, 1. / schscale);
-        _rsvg_affine_multiply (affine, scalematrix, affine);
+        cairo_matrix_t scalematrix;
+
+        cairo_matrix_init_scale (&scalematrix, scwscale, schscale);
+        cairo_matrix_multiply (&caffine, &caffine, &scalematrix);
+        cairo_matrix_init_scale (&scalematrix, 1. / scwscale, 1. / schscale);
+        cairo_matrix_multiply (&affine, &scalematrix, &affine);
     }
 
     /* Draw to another surface */
@@ -386,9 +291,8 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
 
     /* Set up transformations to be determined by the contents units */
     rsvg_state_push (ctx);
-    for (i = 0; i < 6; i++)
-        rsvg_state_current (ctx)->personal_affine[i] =
-            rsvg_state_current (ctx)->affine[i] = caffine[i];
+    rsvg_current_state (ctx)->personal_affine =
+            rsvg_current_state (ctx)->affine = caffine;
 
     /* Draw everything */
     _rsvg_node_draw_children ((RsvgNode *) rsvg_pattern, ctx, 2);
@@ -401,10 +305,10 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
     pattern = cairo_pattern_create_for_surface (surface);
     cairo_pattern_set_extend (pattern, CAIRO_EXTEND_REPEAT);
 
-    cairo_matrix_init (&matrix, affine[0], affine[1], affine[2], affine[3], affine[4], affine[5]);
+    matrix = affine;
+    if (cairo_matrix_invert (&matrix) != CAIRO_STATUS_SUCCESS)
+      goto out;
 
-
-    cairo_matrix_invert (&matrix);
     cairo_pattern_set_matrix (pattern, &matrix);
     cairo_pattern_set_filter (pattern, CAIRO_FILTER_BEST);
 
@@ -413,6 +317,8 @@ _set_source_rsvg_pattern (RsvgDrawingCtx * ctx,
     cairo_pattern_destroy (pattern);
     cairo_destroy (cr_pattern);
     cairo_surface_destroy (surface);
+
+  out:
     if (rsvg_pattern->obj_cbbox || rsvg_pattern->vbox.active)
         _rsvg_pop_view_box (ctx);
 }
@@ -422,36 +328,41 @@ static void
 _set_source_rsvg_paint_server (RsvgDrawingCtx * ctx,
                                guint32 current_color_rgb,
                                RsvgPaintServer * ps,
-                               guint8 opacity, RsvgBbox bbox, guint32 current_colour)
+                               guint8 opacity, RsvgBbox bbox, guint32 current_color)
 {
+    RsvgNode *node;
+
     switch (ps->type) {
-    case RSVG_PAINT_SERVER_LIN_GRAD:
-        _set_source_rsvg_linear_gradient (ctx, ps->core.lingrad, current_color_rgb, opacity, bbox);
-        break;
-    case RSVG_PAINT_SERVER_RAD_GRAD:
-        _set_source_rsvg_radial_gradient (ctx, ps->core.radgrad, current_color_rgb, opacity, bbox);
+    case RSVG_PAINT_SERVER_IRI:
+        node = rsvg_acquire_node (ctx, ps->core.iri);
+        if (node == NULL)
+            break;
+        else if (RSVG_NODE_TYPE (node) == RSVG_NODE_TYPE_LINEAR_GRADIENT)
+            _set_source_rsvg_linear_gradient (ctx, (RsvgLinearGradient *) node, current_color_rgb, opacity, bbox);
+        else if (RSVG_NODE_TYPE (node) == RSVG_NODE_TYPE_RADIAL_GRADIENT)
+            _set_source_rsvg_radial_gradient (ctx, (RsvgRadialGradient *) node, current_color_rgb, opacity, bbox);
+        else if (RSVG_NODE_TYPE (node) == RSVG_NODE_TYPE_PATTERN)
+            _set_source_rsvg_pattern (ctx, (RsvgPattern *) node, opacity, bbox);
+        rsvg_release_node (ctx, node);
         break;
     case RSVG_PAINT_SERVER_SOLID:
-        _set_source_rsvg_solid_colour (ctx, ps->core.colour, opacity, current_colour);
-        break;
-    case RSVG_PAINT_SERVER_PATTERN:
-        _set_source_rsvg_pattern (ctx, ps->core.pattern, opacity, bbox);
+        _set_source_rsvg_solid_color (ctx, ps->core.color, opacity, current_color);
         break;
     }
 }
 
 static void
-_set_rsvg_affine (RsvgCairoRender * render, const double affine[6])
+_set_rsvg_affine (RsvgCairoRender * render, cairo_matrix_t *affine)
 {
     cairo_t * cr = render->cr;
     cairo_matrix_t matrix;
     gboolean nest = cr != render->initial_cr;
 
     cairo_matrix_init (&matrix,
-                       affine[0], affine[1],
-                       affine[2], affine[3],
-                       affine[4] + (nest ? 0 : render->offset_x),
-                       affine[5] + (nest ? 0 : render->offset_y));
+                       affine->xx, affine->yx,
+                       affine->xy, affine->yy,
+                       affine->x0 + (nest ? 0 : render->offset_x),
+                       affine->y0 + (nest ? 0 : render->offset_y));
     cairo_set_matrix (cr, &matrix);
 }
 
@@ -460,10 +371,10 @@ rsvg_cairo_create_pango_context (RsvgDrawingCtx * ctx)
 {
     PangoFontMap *fontmap;
     PangoContext *context;
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
 
     fontmap = pango_cairo_font_map_get_default ();
-    context = pango_cairo_font_map_create_context (PANGO_CAIRO_FONT_MAP (fontmap));
+    context = pango_font_map_create_context (fontmap);
     pango_cairo_update_context (render->cr, context);
     pango_cairo_context_set_resolution (context, ctx->dpi_y);
     return context;
@@ -472,78 +383,91 @@ rsvg_cairo_create_pango_context (RsvgDrawingCtx * ctx)
 void
 rsvg_cairo_render_pango_layout (RsvgDrawingCtx * ctx, PangoLayout * layout, double x, double y)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
-    RsvgState *state = rsvg_state_current (ctx);
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    RsvgState *state = rsvg_current_state (ctx);
     PangoRectangle ink;
     RsvgBbox bbox;
+    PangoGravity gravity = pango_context_get_gravity (pango_layout_get_context (layout));
+    double rotation;
 
-    _rsvg_cairo_set_text_antialias (render->cr, state->text_rendering_type);
+    cairo_set_antialias (render->cr, state->text_rendering_type);
 
-    _set_rsvg_affine (render, state->affine);
+    _set_rsvg_affine (render, &state->affine);
 
     pango_layout_get_extents (layout, &ink, NULL);
 
-    rsvg_bbox_init (&bbox, state->affine);
-    bbox.x = x + ink.x / (double)PANGO_SCALE;
-    bbox.y = y + ink.y / (double)PANGO_SCALE;
-    bbox.w = ink.width / (double)PANGO_SCALE;
-    bbox.h = ink.height / (double)PANGO_SCALE;
+    rsvg_bbox_init (&bbox, &state->affine);
+    if (PANGO_GRAVITY_IS_VERTICAL (gravity)) {
+        bbox.rect.x = x + (ink.x - ink.height) / (double)PANGO_SCALE;
+        bbox.rect.y = y + ink.y / (double)PANGO_SCALE;
+        bbox.rect.width = ink.height / (double)PANGO_SCALE;
+        bbox.rect.height = ink.width / (double)PANGO_SCALE;
+    } else {
+        bbox.rect.x = x + ink.x / (double)PANGO_SCALE;
+        bbox.rect.y = y + ink.y / (double)PANGO_SCALE;
+        bbox.rect.width = ink.width / (double)PANGO_SCALE;
+        bbox.rect.height = ink.height / (double)PANGO_SCALE;
+    }
     bbox.virgin = 0;
 
+    rotation = pango_gravity_to_rotation (gravity);
     if (state->fill) {
-    cairo_move_to (render->cr, x, y);
-    rsvg_bbox_insert (&render->bbox, &bbox);
+        cairo_save (render->cr);
+        cairo_move_to (render->cr, x, y);
+        rsvg_bbox_insert (&render->bbox, &bbox);
         _set_source_rsvg_paint_server (ctx,
                                        state->current_color,
                                        state->fill,
                                        state->fill_opacity,
-                                       bbox, rsvg_state_current (ctx)->current_color);
-
+                                       bbox, rsvg_current_state (ctx)->current_color);
+        if (rotation != 0.)
+            cairo_rotate (render->cr, -rotation);
         pango_cairo_show_layout (render->cr, layout);
+        cairo_restore (render->cr);
     }
 
     if (state->stroke) {
+        cairo_save (render->cr);
         cairo_move_to (render->cr, x, y);
         rsvg_bbox_insert (&render->bbox, &bbox);
-        pango_cairo_layout_path (render->cr, layout);
 
         _set_source_rsvg_paint_server (ctx,
                                        state->current_color,
                                        state->stroke,
                                        state->stroke_opacity,
-                                       bbox, rsvg_state_current (ctx)->current_color);
+                                       bbox, rsvg_current_state (ctx)->current_color);
 
-	cairo_set_line_width (render->cr, _rsvg_css_normalize_length (&state->stroke_width, ctx, 'h'));
+        if (rotation != 0.)
+            cairo_rotate (render->cr, -rotation);
+        pango_cairo_layout_path (render->cr, layout);
+
+        cairo_set_line_width (render->cr, _rsvg_css_normalize_length (&state->stroke_width, ctx, 'h'));
+        cairo_set_miter_limit (render->cr, state->miter_limit);
+        cairo_set_line_cap (render->cr, (cairo_line_cap_t) state->cap);
+        cairo_set_line_join (render->cr, (cairo_line_join_t) state->join);
+        cairo_set_dash (render->cr, state->dash.dash, state->dash.n_dash,
+                        _rsvg_css_normalize_length (&state->dash.offset, ctx, 'o'));
         cairo_stroke (render->cr);
+        cairo_restore (render->cr);
     }
 }
 
 void
-rsvg_cairo_render_path (RsvgDrawingCtx * ctx, const RsvgBpathDef * bpath_def)
+rsvg_cairo_render_path (RsvgDrawingCtx * ctx, const cairo_path_t *path)
 {
-    RsvgCairoRender *render = (RsvgCairoRender *) ctx->render;
-    RsvgState *state = rsvg_state_current (ctx);
+    RsvgCairoRender *render = RSVG_CAIRO_RENDER (ctx->render);
+    RsvgState *state = rsvg_current_state (ctx);
     cairo_t *cr;
-    RsvgBpath *bpath;
-    int i;
-    int need_tmpbuf = 0;
     RsvgBbox bbox;
+    double backup_tolerance;
 
-    if (state->fill == NULL && state->stroke == NULL)
-        return;
-
-    need_tmpbuf = ((state->fill != NULL) && (state->stroke != NULL) && state->opacity != 0xff)
-        || state->clip_path_ref || state->mask || state->filter
-        || (state->comp_op != RSVG_COMP_OP_SRC_OVER);
-
-    if (need_tmpbuf)
-        rsvg_cairo_push_discrete_layer (ctx);
+    rsvg_cairo_push_discrete_layer (ctx);
 
     cr = render->cr;
 
-	_rsvg_cairo_set_shape_antialias (cr, state->shape_rendering_type);
+    cairo_set_antialias (cr, state->shape_rendering_type);
 
-    _set_rsvg_affine (render, state->affine);
+    _set_rsvg_affine (render, &state->affine);
 
     cairo_set_line_width (cr, _rsvg_css_normalize_length (&state->stroke_width, ctx, 'h'));
     cairo_set_miter_limit (cr, state->miter_limit);
@@ -552,66 +476,60 @@ rsvg_cairo_render_path (RsvgDrawingCtx * ctx, const RsvgBpathDef * bpath_def)
     cairo_set_dash (cr, state->dash.dash, state->dash.n_dash,
                     _rsvg_css_normalize_length (&state->dash.offset, ctx, 'o'));
 
-    for (i = 0; i < bpath_def->n_bpath; i++) {
-        bpath = &bpath_def->bpath[i];
-
-        switch (bpath->code) {
-        case RSVG_MOVETO:
-            cairo_close_path (cr);
-            /* fall-through */
-        case RSVG_MOVETO_OPEN:
-            cairo_move_to (cr, bpath->x3, bpath->y3);
-            break;
-        case RSVG_CURVETO:
-            cairo_curve_to (cr, bpath->x1, bpath->y1, bpath->x2, bpath->y2, bpath->x3, bpath->y3);
-            break;
-        case RSVG_LINETO:
-            cairo_line_to (cr, bpath->x3, bpath->y3);
-            break;
-        case RSVG_END:
-            break;
-        }
-    }
-
-    rsvg_bbox_init (&bbox, state->affine);
-
-    if (state->fill != NULL) {
+    cairo_append_path (cr, path);
+
+    rsvg_bbox_init (&bbox, &state->affine);
+
+    backup_tolerance = cairo_get_tolerance (cr);
+    cairo_set_tolerance (cr, 1.0);
+    /* dropping the precision of cairo's bezier subdivision, yielding 2x
+       _rendering_ time speedups, are these rather expensive operations
+       really needed here? */
+
+    /* Bounding box for fill
+     *
+     * Unlike the case for stroke, for fills we always compute the bounding box.
+     * In GNOME we have SVGs for symbolic icons where each icon has a bounding
+     * rectangle with no fill and no stroke, and inside it there are the actual
+     * paths for the icon's shape.  We need to be able to compute the bounding
+     * rectangle's extents, even when it has no fill nor stroke.
+     */
+    {
         RsvgBbox fb;
-        rsvg_bbox_init (&fb, state->affine);
-        cairo_fill_extents (cr, &fb.x, &fb.y, &fb.w, &fb.h);
-        fb.w -= fb.x;
-        fb.h -= fb.y;
+        rsvg_bbox_init (&fb, &state->affine);
+        cairo_fill_extents (cr, &fb.rect.x, &fb.rect.y, &fb.rect.width, &fb.rect.height);
+        fb.rect.width -= fb.rect.x;
+        fb.rect.height -= fb.rect.y;
         fb.virgin = 0;
         rsvg_bbox_insert (&bbox, &fb);
     }
+
+    /* Bounding box for stroke */
     if (state->stroke != NULL) {
         RsvgBbox sb;
-        rsvg_bbox_init (&sb, state->affine);
-        cairo_stroke_extents (cr, &sb.x, &sb.y, &sb.w, &sb.h);
-        sb.w -= sb.x;
-        sb.h -= sb.y;
+        rsvg_bbox_init (&sb, &state->affine);
+        cairo_stroke_extents (cr, &sb.rect.x, &sb.rect.y, &sb.rect.width, &sb.rect.height);
+        sb.rect.width -= sb.rect.x;
+        sb.rect.height -= sb.rect.y;
         sb.virgin = 0;
         rsvg_bbox_insert (&bbox, &sb);
     }
 
+    cairo_set_tolerance (cr, backup_tolerance);
+
     rsvg_bbox_insert (&render->bbox, &bbox);
 
     if (state->fill != NULL) {
         int opacity;
-        if (state->fill_rule == FILL_RULE_EVENODD)
-            cairo_set_fill_rule (cr, CAIRO_FILL_RULE_EVEN_ODD);
-        else                    /* state->fill_rule == FILL_RULE_NONZERO */
-            cairo_set_fill_rule (cr, CAIRO_FILL_RULE_WINDING);
 
-        if (!need_tmpbuf)
-            opacity = (state->fill_opacity * state->opacity) / 255;
-        else
-            opacity = state->fill_opacity;
+        cairo_set_fill_rule (cr, state->fill_rule);
+
+        opacity = state->fill_opacity;
 
         _set_source_rsvg_paint_server (ctx,
                                        state->current_color,
                                        state->fill,
-                                       opacity, bbox, rsvg_state_current (ctx)->current_color);
+                                       opacity, bbox, rsvg_current_state (ctx)->current_color);
 
         if (state->stroke != NULL)
             cairo_fill_preserve (cr);
